$IF 0
  FILE: MP002.BAS FOR PB/CC 2.0 (Easy TO PORT TO PB/DLL)
'  8.10.00  This is the code for the article, downloadable version with all procedures
'  Input: file_1.in, File_2.in    172-byte random files
'  Outputs: File_1.out  ==> selected data meeting qualification and non-duplicate
'           Dupfile.out ==> duplicate records found
'           report.out  ==> summary statistics
'           PostofficeFile ==> 'keepers' sorted by zip code
' Author: Michael C. Mattias Racine WI USA
' This code is placed in the public domain by the author, who expressly waives any
' claim of copyright or patent available.//s// Michael C. Mattias  8-11-2000

$ENDIF

' don't allow PB to assign REGISTER variables.
#REGISTER NONE
#DEBUG ERROR ON
$INCLUDE "WIN32API.INC"

' The data files: input and output
TYPE MailListType
  CName    AS STRING * 40
  Street  AS STRING *  35
  City    AS STRING *  25
  State   AS STRING *  2
  ZipCode AS STRING *  9
  AreaCode AS STRING * 3
  Phone   AS STRING *  7    ' dashes removed
  Contact AS STRING * 30
  Space1  AS STRING *  1
  Number1 AS LONG
  Code1   AS STRING * 3
  Code2   AS STRING * 1
  Dollars1 AS LONG          ' Dollars are stored in pennies
  Dollars2 AS LONG
  Number2  AS INTEGER
  EOL      AS STRING * 2    ' always $CRLF
END TYPE

TYPE KeyValueType
     CName  AS STRING * 40
     ZipCode  AS STRING * 5
END TYPE

TYPE KeyType
     KeyValue AS KeyValueType
END TYPE


DECLARE FUNCTION MergeFiles (FileA AS STRING, FileB AS STRING, HReport AS LONG, Merged() AS MailListType) AS LONG
DECLARE FUNCTION SelectThisRecord (I AS MailListType) AS LONG
DECLARE FUNCTION BuildKeyArray (KeyArray() AS KeyType, MergedFile() AS MailListType) AS LONG
DECLARE FUNCTION MergePurge (ActionCode AS LONG, A() AS MailListType, K() AS KeyType, hReport AS LONG, hKeep AS LONG, hDiscard AS LONG) AS LONG
DECLARE FUNCTION PostOffice (M() AS MailListType, hReport AS LONG, PostOfficeFile AS STRING) AS LONG

' ****  EQUATES USED BY THIS APPLICATION *****
%ACTION_PURGE_DUPS = 1&
%ACTION_APPEARS_TWICE = 2&

FUNCTION WinMain (BYVAL hCurInstance  AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpszCmdLine         AS ASCIIZ PTR, _
                  BYVAL nCmdShow      AS LONG) EXPORT AS LONG

   DIM ThisFile AS ASCIIZ * 128
   DIM Stat AS LONG
   DIM FilePath AS STRING, FileA AS STRING, FileB AS STRING
   DIM hReport AS LONG, ReportFile AS STRING, PostOfficeFile AS STRING

   'FilePath = "C:\Software_Development\PBCC20\Work\Merge-Purge\"
   FilePath = CURDIR$ + "/"           '  CURDIR$ comes with no trailing slash
   ReportFile = FilePath & "Report.out"    ' output report
   FileA = FilePath & "file_1.in"          ' two mailing list files courtesy of your boss.
   FileB = FilePath & "file_2.in"

   hReport = FREEFILE
   OPEN ReportFile FOR OUTPUT AS hReport
   Stat = GetModuleFileName (hCurInstance, ThisFile, SIZEOF(ThisFile) )
   PRINT #HReport, ThisFile & " begins at " & TIME$ & " " & " on " & DATE$
   PRINT #hReport,
   REDIM MergedFile(1) AS MailListType                          ' dynamic array to hold the combined list
   Stat = MergeFiles (FileA, FileB, hReport, MergedFile())      ' load the files and put them together
   IF ISTRUE (Stat) THEN
      PRINT #Hreport, " No Records Selected, Terminating."
      CLOSE hReport
      FUNCTION =1
      EXIT FUNCTION
   ELSE
      PRINT #hreport, "Merged File Contains" & STR$(UBOUND(MergedFile,1)) & " entries"
   END IF
'  <<< CREATE THE SORT KEY FOR THE JOINED FILE>>>>
    REDIM KeyArray (UBOUND(MergedFile,1)) AS KeyType
    Stat= BuildKeyArray (KeyArray(), MergedFile())
'  <<< SORT THE KEY ARRAY, TAG ALONG THE MAIN DATA ARRAY >>>
    ARRAY SORT KeyArray(1), TAGARRAY MergedFile()

    LOCAL hKeep AS LONG, hDiscard AS LONG, KeepFile AS STRING, DiscardFile AS STRING
' <<<< DO THE PURGE OF DUPLICATES >>>>>
    KeepFile = FilePath & "nodups_keep.out"
    DiscardFile = FilePath & "nodups_discard.out"
    IF DIR$(KeepFile) <> "" THEN KILL KeepFile: IF DIR$(DiscardFile) <> "" THEN KILL DiscardFile
    hKeep = FREEFILE
    OPEN KeepFile FOR BINARY AS hKeep BASE=0
    hDiscard = FREEFILE
    OPEN DiscardFile FOR BINARY AS hDiscard
    Stat = MergePurge (%ACTION_PURGE_DUPS, MergedFile(), KeyArray(), hReport, hKeep, hDiscard)
    CLOSE hKeep, hDiscard
' <<< FIND THE ITEMS WHICH APPEAR TWICE >>>
    KeepFile = FilePath & "both_keep.out"
    DiscardFile = FilePath & "both_discard.out"
    IF DIR$(KeepFile) <> "" THEN KILL KeepFile: IF DIR$(DiscardFile) <> "" THEN KILL DiscardFile
    hKeep = FREEFILE
    OPEN KeepFile FOR BINARY AS hKeep BASE=0
    hDiscard = FREEFILE
    OPEN DiscardFile FOR BINARY AS hDiscard
    Stat = MergePurge (%ACTION_APPEARS_TWICE, MergedFile(), KeyArray(), hReport, hKeep, hDiscard)
    CLOSE hKeep, hDiscard
'<<<< Do the Post Office file
     PostOfficeFile = FilePath & "Post_office.out"
     Stat = PostOffice (MergedFile(), hReport, PostOfficeFile)

    PRINT #hReport,
    PRINT #hReport, " **** END OF REPORT ****"
    CLOSE hReport
    PRINT "End of Job, any key to view report";
    WAITKEY$
    Stat = SHELL ("notepad.exe" & " " & ReportFile)
    FUNCTION = 0
END FUNCTION


FUNCTION MergeFiles (FileA AS STRING, FileB AS STRING, HReport AS LONG, Merged() AS MailListType) AS LONG

  DIM NRecs AS LONG, hIn AS LONG, IBuff AS MailListType, I AS LONG, NSelected AS LONG, Nrejected AS LONG
  DIM E AS LONG
' load filea
   hIn = FREEFILE
   OPEN FileA FOR RANDOM AS hIn LEN=SIZEOF(IBuff)
   Nrecs = LOF(hiN) \ SIZEOF(IBuff)
   PRINT # HReport, "Found " & STR$(Nrecs) & " records in input file " & FileA
   REDIM Merged (Nrecs) AS MaillistType    ' resize array to handle this
   E = ERRCLEAR
   IF E THEN
       PRINT "Error " & STR$(E) & " on First REDIM"
       J$ = WAITKEY$
   END IF
   FOR I = 1 TO nRecs
       GET #hIn,I,IBuff                         ' read record
       IF SelectThisRecord (Ibuff) THEN         ' qualify it
          INCR nSelected
          Merged (NSelected) = IBuff
       ELSE
          INCR NRejected
       END IF
   NEXT I
   CLOSE hIn
' add file B
  hIn = FREEFILE
  OPEN FileB FOR RANDOM AS hIn LEN=SIZEOF(IBuff)
  Nrecs = LOF(hIN) \ SIZEOF(IBuff)
  PRINT # HReport, "Found " & STR$(Nrecs) & " records in input file " & FileB

' make our array big enough to handle what we have already plus "worst case" all of the FileB
  REDIM PRESERVE Merged (NSelected + Nrecs) AS MailListType
  E = ERRCLEAR
  IF E THEN
      PRINT "Error " & STR$(e) & " on REDIM PRESERVE for fileB"
  END IF

  FOR I = 1 TO Nrecs
       GET #hIn,I,IBuff                         ' read record
       IF SelectThisRecord (Ibuff) THEN         'qualify it
          INCR nSelected
          Merged (NSelected) = IBuff
       ELSE
          INCR NRejected
       END IF
  NEXT I
  CLOSE hIn

  PRINT # HReport, "Selected" & STR$(NSelected) & " records for processing."
  PRINT # HReport, "Rejected" & STR$(NRejected) & " records on qualifications."
  IF ISTRUE Nselected THEN
    REDIM PRESERVE Merged(nSelected) AS MailListType
    FUNCTION = 0
  ELSE
    FUNCTION = -1&
  END IF

END FUNCTION

FUNCTION SelectThisRecord (I AS MailListType) AS LONG
   ' returns: TRUE if this record should be included
   ' false if not

    IF I.Street = SPACE$(SIZEOF(I.Street)) _
     OR I.City  = SPACE$(SIZEOF(I.City))   _
     OR I.State = SPACE$(SIZEOF(I.State)) _
     OR I.ZipCode = SPACE$(SIZEOF(I.ZipCode)) THEN
        FUNCTION = %FALSE
    ELSE
        FUNCTION = %TRUE
    END IF

END FUNCTION

FUNCTION BuildKeyArray (KeyArray() AS KeyType, MergedFile() AS MailListType) AS LONG
 LOCAL I AS LONG
        FOR I = 1 TO UBOUND(MergedFile,1)
          KeyArray(I).KeyValue.CName = MergedFile(I).CName
          KeyArray(I).KeyValue.ZipCode = MergedFile(I).ZipCode
        NEXT

        FUNCTION = 0

END FUNCTION


FUNCTION MergePurge (ActionCode AS LONG, M() AS MailListType, K() AS KeyType, hReport AS LONG, hKeep AS LONG, hDiscard AS LONG) AS LONG
' at entry: hReport is open output, hKeep and hDiscard are open Binary
'%ACTION_PURGE_DUPS = 1&; %ACTION_APPEARS_TWICE = 2&

  LOCAL ThisKey AS STRING, LastKey AS STRING, nKeep AS LONG, nDiscard AS LONG, I AS LONG
  LOCAL Oh AS LONG   ' generic handle...

  PRINT #Hreport, "Processing... ";
  IF ActionCode = %ACTION_PURGE_DUPS THEN
     PRINT #hReport, "Purge Duplicates"
  ELSE
     PRINT #hReport, "Names Appearing more than once."
  END IF

  ThisKey = SPACE$(SIZEOF(K(1)))        ' prime the buffer
  FOR I = 1 TO UBOUND(M,1)
     LSET ThisKey =  K(I)
     IF ThisKey <> LastKey THEN
          IF ActionCode = %ACTION_PURGE_DUPS THEN
             OH = hKeep
          ELSE
             OH = hDiscard
          END IF
    ELSE
          IF ActionCode = %ACTION_APPEARS_TWICE THEN
             OH = hKeep
          ELSE
             OH = hDiscard
          END IF
    END IF
    PUT #OH,,M(I)
    IF OH = hKeep THEN
       INCR nKeep
    ELSE
       INCR nDiscard
    END IF
    LastKey = ThisKey
 NEXT I

 PRINT #HReport, "  Wrote " & STR$(nKeep) & " records to 'keep' file " & FILENAME$(hKeep)
 PRINT #HReport, "  Wrote " & STR$(nDiscard) & " records to 'discard' file " & FILENAME$(hDiscard)
 FUNCTION = 0
END FUNCTION

%MINIMUM_ZIP_5  = 5  ' in truth this value is 10, but this is a demo!

FUNCTION PostOffice (M() AS MailListType, hReport AS LONG, PostOfficeFile AS STRING) AS LONG
   ' INPUT  M(), K(), hReport (open), PostOfficeFile
   ' OUTPUT: M() is written to PostOfficeFile in K() order and hReport includes the ZipCode totals

   DIM I AS LONG, hPO AS LONG, Zip3 AS STRING, Zip5 AS STRING, LastZip3 AS STRING, LastZip5 AS STRING
   DIM nZip3 AS LONG, nZip5 AS LONG, nPrinted AS LONG ' running totals of current pieces by zip5 or zip3, reported

   ' Sort the M Array by ZipCode
   LOCAL BaseOffset AS LONG, KeyOffset AS LONG, SortFrom AS LONG, SortTo AS LONG
   BaseOffset = VARPTR(M(1))
   KeyOffset  = VARPTR(M(1).ZipCode)
   SortFrom = KeyOffset - BaseOffset + 1
   SortTo   = SortFrom + SIZEOF(M(1).ZipCode)

   ARRAY SORT M(1) ,FROM SortFrom TO SortTo


   PRINT #hReport,
   PRINT #hReport, " ** POST OFFICE SUMMARY BY ZIP CODE **"
   PRINT #hReport, " Zip5     Zip3        Count   "
   PRINT #hReport, " ----     -----       ---------"
   PRINT #hReport,

   hPO = FREEFILE
   OPEN PostOfficeFile FOR BINARY AS hPO BASE=0
   nZip5 = 0: nZip3 = 0: nPrinted = 0
   LastZip5 = "": LastZip3 = ""
   FOR I = 1 TO UBOUND (M,1)
       Zip5 = LEFT$(M(I).ZipCode, 5)
       Zip3 = LEFT$(Zip5,3)

       IF (Zip3 = LastZip3) AND (Zip5 <> LastZip5) THEN
          IF nZip5 >= %Minimum_ZIP_5  THEN   ' this item can be ZIP_5 bundled, print it
            PRINT #hReport, LastZip5 & SPACE$(10) & FORMAT$(nZip5, "###,###")
            nPrinted = nPrinted + nZip5
            nZip3 = nZip3 - nZip5            ' subtract from Zip 3, printed here
          END IF
          nZip5 = 0                           ' none left for this zip5
         ' ELSE                               ' insufficient for Zip5, put in Zip3
         '   nZip3 = nZip3 + nZip5            ' add to in current Zip3
         ' END IF
       ELSEIF Zip3 <> LastZip3 THEN
            IF nZip5 >= %Minimum_ZIP_5  THEN   ' this item can be ZIP_5 bundled, print it
               PRINT #hReport, LastZip5 & SPACE$(10) & FORMAT$(nZip5, "###,###")
               nPrinted = nPrinted + nZip5
               nZip3 = nZip3 - nZip5           ' sibtract from the running total of ZIP3
               nZip5 = 0
            END IF
            IF nZip3 > 0 THEN                  ' any left in this Zip3?
               PRINT #hReport, SPACE$(10) & LastZip3 & "**" & FORMAT$(nZip3, "###,###")
               nPrinted = nPrinted + nZip3
            END IF
            nZip3 = 0                           'reset both, this item
            nZip5 = 0
      END IF
      LastZip5 = Zip5 : LastZip3 = Zip3   ' update running totals for this item
      INCR nZip5 :  INCR nZip3
      PUT #hPO,,M(I)                      ' write output (Zip code order)

   NEXT I
   ' report if we did not have a control break on the last item in the array
   IF NZip3 > 1 OR nZip5 >1  THEN            '  then the last item did not force a control break,
                                             '  so we check if ZIP5 is satisfied
      IF nZip5 >= %Minimum_ZIP_5  THEN       '
        PRINT #hReport, Zip5 & SPACE$(10) & FORMAT$(nZip5, "###,###")
        nPrinted = nPrinted + nZip5
      ELSE                                   ' insufficient for Zip5, puit in Zip3
        PRINT #hReport, SPACE$(10) & Zip3 & "**" & FORMAT$(nZip3, "###,###")
        nPrinted = nPrinted + nZip3
      END IF
   END IF

   CLOSE hPo
   PRINT #hReport,
   PRINT #hReport, " Records in/out            : " & FORMAT$(UBOUND(M,1),"###,###")
   PRINT #hReport, " Zip Code records printed  : " & FORMAT$(nPrinted, "###,###")
   PRINT #hReport, " File Sorted by Zip Code written to " & PostOfficeFile
   PRINT #hReport,
   PRINT #hReport, "  ** END OF POST OFFICE SUMMARY **"
   PRINT #hReport,
   FUNCTION = 0

END FUNCTION




                                                                                                                                                         